/*   Ukzka komunikace SPI s Disp1704 
 nutno pilinkovat knihovnu bcm2835, nap. gcc -Wall -c "%f" -lbcm2835
 */


#include <stdio.h>
#include <stdlib.h> 
#include <unistd.h>
#include <bcm2835.h>
#include <string.h>
#include <time.h>
#include "rkods.h"


int sec; int min;
char ht[32];
char str[32]="\xB5"; //"\xB5";
char buf[4],wbuf[4];
char chr=0, dsz=0;

char tbuf[32];
int temp = 0;	

  //uivatelsk znaky

char ASCII[] = {
 0x02, 0x04, 0x0E, 0x01, 0x0F, 0x11, 0x0F, 0, //     
 0x0A, 0x04, 0x0E, 0x10, 0x10, 0x11, 0x0E, 0, // 
 0x0A, 0x04, 0x0E, 0x11, 0x1F, 0x10, 0x0E, 0, // 
 0x02, 0x04, 0x0C, 0x04, 0x04, 0x04, 0x0E, 0, //  
 0x0A, 0x04, 0x16, 0x19, 0x10, 0x10, 0x10, 0, //  
 0x0A, 0x04, 0x0E, 0x10, 0x0E, 0x01, 0x1E, 0, //   
 0x02, 0x04, 0x11, 0x11, 0x11, 0x13, 0x0D, 0, // 
 0x02, 0x04, 0x11, 0x11, 0x0F, 0x01, 0x0E, 0  //   
     
};


int datum(){
	
     static time_t tim;
     static struct tm td;
     int wday=0;

	 tim=time(&tim);
	 td=*localtime(&tim);
	
	 wday=td.tm_wday;
	 if(wday==0) wday=7; 
     // sprintf(ht,"%02d:%02d:%02d %02d.%02d.%02d %1d",td.tm_hour,td.tm_min,td.tm_sec,td.tm_mday,td.tm_mon+1,td.tm_year-100, wday);   
     sprintf(ht,"%02d:%02d:%02d",td.tm_hour,td.tm_min,td.tm_sec);   
     printf("%02d:%02d:%02d\n",td.tm_hour,td.tm_min,td.tm_sec);   
     // printf("%02d.%02d.%02d %02d:%02d\n", td.tm_mday,td.tm_mon+1,td.tm_year-100, td.tm_hour,td.tm_min);   
     min = td.tm_min; sec = td.tm_sec;   

     return 0;
 }

int main(){
	
char len;
	
 if (!bcm2835_init())
	return 1;
		
bcm2835_spi_begin();   // spust spi
  	
bcm2835_spi_setChipSelectPolarity(BCM2835_SPI_CS0, 0);  // aktivn je 0
bcm2835_spi_setChipSelectPolarity(BCM2835_SPI_CS1,0);

bcm2835_spi_setClockDivider(BCM2835_SPI_CLOCK_DIVIDER_2048);  // frekvence SCLK  122 kHz
bcm2835_spi_setDataMode(BCM2835_SPI_MODE0);					// md 0
bcm2835_spi_chipSelect(BCM2835_SPI_CS0);					// pouijeme CS0


while(1){
datum();
/*
bcm2835_spi_transfer(CMND);   //vysle matice uivatelskch znak
bcm2835_spi_transfer(0x40);
bcm2835_spi_writenb( ASCII, 64); 
*/
bcm2835_spi_transfer(CMND);   // maze cely displ.
bcm2835_spi_transfer(1); 

//bcm2835_spi_transfer(DMOD); // font pro bargraf
//bcm2835_spi_transfer(FNT1);   

bcm2835_spi_transfer(TEMP);  //teplota 
usleep(10);
bcm2835_spi_transfern(buf,2); 
temp=buf[0]+ (buf[1]<<8);

bcm2835_spi_transfer(BUTN);
usleep(10 );
chr = bcm2835_spi_transfer(0x0);  //nacte tlacitka


bcm2835_spi_transfer(RTXT);     //nate text
usleep(10); 
bcm2835_spi_transfern(tbuf,16);

bcm2835_spi_transfer(CMND);    // nastav pozici cursoru
bcm2835_spi_transfer(ROW2);

len = strlen(ht );
bcm2835_spi_writenb( ht, len);    //vysle text - as

bcm2835_spi_transfer(BUFF);    //
usleep(10);
dsz = bcm2835_spi_transfer(0);  //nacte dsize

bcm2835_spi_transfer(CMND);    // nastav pozici cursoru
bcm2835_spi_transfer(ROW1);

len = strlen(str );
bcm2835_spi_writenb( str, len);    //vysle text

bcm2835_spi_transfer(CMND);    // nastav pozici cursoru
bcm2835_spi_transfer(ROW1+5);


char ledl = 0xE0;

bcm2835_spi_transfer(BRIG);    // nastav osvetleni
bcm2835_spi_transfer(ledl);
 
 printf("temp=0x%x \n",temp);
 printf("but=0x%x \n",chr); 
 printf("bf=%d\n",dsz);
 printf("%s\n",tbuf);
  
  

chr=getchar();
if(chr==0x20)break;
}
bcm2835_spi_transfer(RSET); //RESET

bcm2835_spi_end();

bcm2835_close();

return 0;
}
