#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <termios.h>
#include <string.h>
#include <time.h>
#include <errno.h>
#include <stdlib.h>
#include <ctype.h>
#include <bcm2835.h>
#include "rkods.h"

char rx_buf[64];
char buf[2];
char text[]="sla 12345678";
int fd;
struct termios options, oldio;



int main(){
int chr = 0;	
int vol=0, vdd=0, but=0, temp=0;

  
   fd = open("/dev/ttyAMA0", O_RDWR | O_NOCTTY | O_NDELAY);

if(fd ==-1){printf("Error\n");}




tcgetattr(fd, &oldio);
bzero(&options, sizeof(options) );

options.c_cflag = B57600 | CS8 | CLOCAL |  CREAD;
options.c_iflag = IGNPAR;
options.c_oflag = 0;
options.c_lflag = 0;
tcflush(fd, TCIFLUSH);
tcsetattr(fd, TCSANOW, &options);

  
  
while(1){ 
	

buf[0]=CMND; buf[1]=1;
write(fd,buf , 2);

buf[0]=CMND; buf[1]=ROW1;
write(fd,buf , 2);

write(fd, text, strlen(text));

buf[0]=BRIG; buf[1]=0x80;
write(fd,buf , 2);


buf[0]=BUTN;
write(fd,buf , 1);
while(!1==read(fd, rx_buf,1));
but=rx_buf[0];

buf[0]=TEMP; 
write(fd,buf , 1);
while(!2==read(fd, rx_buf,2));
temp = rx_buf[0] + (rx_buf[1]<<8);

buf[0]=VOLT;
write(fd,buf , 1);
while(!2==read(fd, rx_buf,2));
vol = rx_buf[0] + (rx_buf[1]<<8);

buf[0]=VDD;
write(fd,buf , 1);
while(!2==read(fd, rx_buf,2));
vdd = rx_buf[0] + (rx_buf[1]<<8);

buf[0]=DMOD; buf[1]=FNT1;
write(fd,buf , 2);

buf[0]=CMND; buf[1]=ROW2;
write(fd,buf , 2);

buf[0]=BARG; buf[1]=48;
write(fd,buf , 2);



buf[0]=RTXT; 
write(fd,buf , 1);
usleep(20);
while(!1==read(fd, rx_buf,8));
printf("%s\n",rx_buf);

printf("Tla =  0x%x\n",but);
printf("Teplota = 0x%x\n",temp);
printf("Napt = 0x%x\n",vol);
printf("Vdd = 0x%x\n",vdd);



chr = getchar();
if(chr==0x20) break;

}

buf[0]=RSET; 
write(fd,buf , 1);
tcdrain(fd);
close(fd);
tcsetattr(fd, TCSANOW, &oldio);

return 0;  
	
}
